package com.link.core.basic.es.service;

import com.link.core.basic.model.BasicModel;
import java.util.List;
import org.elasticsearch.search.builder.SearchSourceBuilder;

public interface BasicEsService<T extends BasicModel> {
   List<T> queryByExamplePage(T entity) throws Exception;

   List<T> scrollQueryByExamplePage(T entity) throws Exception;

   List<T> queryAll(T entity) throws Exception;

   List<T> queryAllByAggregation(T entity) throws Exception;

   void insert(T entity) throws Exception;

   void batchInsert(List<T> list) throws Exception;

   void batchUpsert(List<T> list) throws Exception;

   T preDefaultValue(T entity) throws Exception;

   T postDefaultValue(T entity) throws Exception;

   void upsert(T entity) throws Exception;

   void update(T entity) throws Exception;

   void updateByCondition(T entity) throws Exception;

   void reloadById(T entity) throws Exception;

   void batchReload(List<T> list) throws Exception;

   T queryById(T entity) throws Exception;

   T queryById(String entityId) throws Exception;

   void deleteById(T entity) throws Exception;

   void deleteById(String entityId) throws Exception;

   void batchDelete(List<T> list) throws Exception;

   boolean checkData(T entity) throws Exception;

   void beforUpdate(T entity) throws Exception;

   void afterUpdate(T entity) throws Exception;

   void beforUpdateByCondition(SearchSourceBuilder sourceBuilder, T entity) throws Exception;

   void afterUpdateByCondition(T entity) throws Exception;

   void beforInsert(T entity) throws Exception;

   void afterInsert(T entity) throws Exception;

   void beforDelete(T entity) throws Exception;

   void beforUpsert(T entity) throws Exception;

   void afterUpsert(T entity) throws Exception;

   boolean isInsertFlag(T entity) throws Exception;

   void batchUpdate(List<T> list) throws Exception;

   void afterDelete(T entity) throws Exception;

   void beforReloadById(T entity) throws Exception;

   void afterReloadById(T entity) throws Exception;
}
